from __future__ import generators
import plus
import Arenas
import random
import Hazards
import math
import ASHaz
import HazardsBlueRay
from random import randint


class RTTourney(Arenas.SuperArena):
    "Official GameTechMods Championship arena. Outer walls will lower after 2:45 minutes, turning hazards off will prevent this."
    name = "GTM Championship Arena"
    preview = "RTtourney/preview.bmp"
    game_types = ['DEATHMATCH', 'BATTLE ROYAL', 'TEAM MATCH']
    extent = (-11, 11, 11, -11)

    def __init__(self):
        Arenas.SuperArena.__init__(self, "Arenas/RTtourney/tourney.gmf")
        plus.setBackColor(0,0,0)
        degrad = 0.01745
        self.AddStaticCamera("                Overview", (0, 7.8, -17.5), (35*degrad,0), 68*degrad)
        self.AddStaticCamera("                Corner Cam 1", (4, 0, 4), (10*degrad,45*degrad),72*degrad)
        self.AddStaticCamera("                Corner Cam 2", (4, 0, -4), (10*degrad,135*degrad), 72*degrad)
        self.AddStaticCamera("                Corner Cam 3", (-4, 0, -4), (10*degrad,225*degrad), 72*degrad)
        self.AddStaticCamera("                Corner Cam 4", (-4, 0, 4), (10*degrad,315*degrad), 72*degrad)
        self.AddWatchCamera("                Watch Cam 1", (15, 7.8, -15), (6, 37, 40*degrad, 15*degrad))
        self.AddWatchCamera("                Watch Cam 2", (-15, 7.8, 15), (6, 37, 40*degrad, 15*degrad))
        self.AddWatchCamera("                Blade Cam", (0, 2, 0), (5, 25, 65*degrad, 45*degrad))
        self.AddWatchCamera("                Overhead Cam", (0, 7.8, 0), (10, 15, 68*degrad, 58*degrad))
        self.AddWatchCamera("                Audience Cam", (0, 3, -30), (19, 41, 30*degrad, 20*degrad))
        self.players = ()
        self.SetPinned ("bladewall", True)
        self.wallmaster = 0

    def Activate(self, on):
        if on:
            self.players = plus.getPlayers()
        #outer walls
        self.AddCollisionLine((11, 11), (11, -11))
        self.AddCollisionLine((11, -11), (-11, -11))
        self.AddCollisionLine((-11, -11), (-11, 11))
        self.AddCollisionLine((-11, 11), (11, 11))
        Arenas.SuperArena.Activate(self, on)
        

    def HazardsOn(self, on):

        self.prism = self.AddPrismatic("floor", "bladewall", 0, -1, 0, 0, 2, 0)
        self.prism.SetAutoLock(False)
        self.SetSubMaterialSound("bladewall", "metal", 0.55, "Sounds\\nothing.wav")
        self.SetSubMaterialSound("fencecorner", "metal", 1.1, "Sounds\\hzd_hammer_hit2.wav")
        self.SetSubMaterialSound("blade1", "metal", 3, "Sounds\\barrel_collision2.wav")
        self.SetSubMaterialSound("blade2", "metal", 3, "Sounds\\barrel_collision2.wav")
        self.SetSubMaterialSound("floor", "metal", 1.25, "Sounds\\nothing.wav")

        if on:
            self.wallmaster = 0
            if plus.getWeight(0) > 250 or plus.getWeight(1) > 250 or plus.getWeight(2) > 250 or plus.getWeight(3) > 250:
                self.spinner1 = self.GetHinge("Hinge01")
                self.spinner1.SetAutoLocks(False, False)
                self.spinner1.SetPowerSettings(85, 10)
                self.spinner1.Lock(False)
                self.spinner1.SetDirection(100)
            
                self.spinner2 = self.GetHinge("Hinge02")
                self.spinner2.SetAutoLocks(False, False)
                self.spinner2.SetPowerSettings(85, 10)
                self.spinner2.Lock(False)
                self.spinner2.SetDirection(-100)
            else:
                self.spinner1 = self.GetHinge("Hinge01")
                self.spinner1.SetAutoLocks(False, False)
                self.spinner1.SetPowerSettings(35, 4.5)
                self.spinner1.Lock(False)
                self.spinner1.SetDirection(100)
            
                self.spinner2 = self.GetHinge("Hinge02")
                self.spinner2.SetAutoLocks(False, False)
                self.spinner2.SetPowerSettings(35, 4.5)
                self.spinner2.Lock(False)
                self.spinner2.SetDirection(-100)

        else:
            self.wallmaster = 1000
            if plus.getWeight(0) > 250 or plus.getWeight(1) > 250 or plus.getWeight(2) > 250 or plus.getWeight(3) > 250:
                self.spinner1 = self.GetHinge("Hinge01")
                self.spinner1.SetAutoLocks(False, False)
                self.spinner1.SetPowerSettings(85, 10)
                self.spinner1.Lock(False)
                self.spinner1.SetDirection(100)
            
                self.spinner2 = self.GetHinge("Hinge02")
                self.spinner2.SetAutoLocks(False, False)
                self.spinner2.SetPowerSettings(85, 10)
                self.spinner2.Lock(False)
                self.spinner2.SetDirection(-100)
            else:
                self.spinner1 = self.GetHinge("Hinge01")
                self.spinner1.SetAutoLocks(False, False)
                self.spinner1.SetPowerSettings(45, 4.5)
                self.spinner1.Lock(False)
                self.spinner1.SetDirection(100)
            
                self.spinner2 = self.GetHinge("Hinge02")
                self.spinner2.SetAutoLocks(False, False)
                self.spinner2.SetPowerSettings(45, 4.5)
                self.spinner2.Lock(False)
                self.spinner2.SetDirection(-100)

        return Arenas.SuperArena.HazardsOn(self, on)

    def Tick(self):
        self.wallmaster += 1

        for each in self.players:
            if plus.getLocation(each)[1] < -1 and (abs(plus.getLocation(each)[0]) > 11.3 or abs(plus.getLocation(each)[2]) > 11.3):
                plus.eliminatePlayer(each)

        if self.wallmaster == 670:
            self.retractsound = plus.createSound("Sounds/motorloop.wav", False, (0, 0, 0))
            plus.playSound(self.retractsound)

        if self.wallmaster > 670 and self.wallmaster < 680:
            self.SetPinned ("bladewall", False)
            self.prism.Lock(False)
            self.prism.ApplyForce(100)

        return Arenas.SuperArena.Tick(self)

    def __del__(self):
        if self.bHazardsOn:
            plus.removeSound
        Arenas.SuperArena.__del__(self)
        
Arenas.register(RTTourney)
